####################################################################
#           #       #    #######    #######
#          # #     #    #     #    #
#         #   #   #    #     #    #######
#        #     # #    #     #    #
#       #       #    #######    ########
#
#         File: Game.pm
#  Description: Globals for game.pl
#       Author: Niko Oeppert
#        Email: niko.oeppert@wasistnochfrei.de
#          Web: http://www.wasistnochfrei.de
#      Company: master-productions GmbH
#      Version: 1.00
# Copyright (c) 2002 Niko Oeppert
# Redistribution in part or in whole strictly prohibited.
####################################################################
use CGI;
package Global;
################################################################
# variables
# modify the following variables to fit your needs/system
################################################################
#the file where all emails will be stored
$file = "/path/to/solved.txt";
#path to templates
$template_path = "/path/to/templates";
#name of the script
$script_name = "game.pl";
#url of the script
$script_url = "http://yourdomain/amp/game.pl";
#url of images (1-9)
$image_url = "./i";
#image extension
$image_ext = "gif";
#if you set $minute to 1 a user can reuse the form every minute,
#else once an hour - going to improve that...
$minute = "1";
################################################################
# default variables for template output are stored in $config
# feel free to add, modify and remove them
# be sure to define the url to your script
################################################################
sub config {
my $config;
#path to images
$config->{'image_url'} = $Global::image_url;
#extension of your images (gif|jpg) which should be numbered from 1-9
$config->{'image_ext'} = $Global::image_ext;
# copyright notice please leave as is
$config->{'copy'} = "<p align=center>&copy; 2002 <a href=http://www.wasistnochfrei.de>Niko Oeppert</a></p>";
return $config;
}
################################################################
# error output
################################################################
sub error {
my $err_msg;
my $variables;
my $error = $_[0];
# list of possible errors
$err_msg->{'nofile'} = "The requested template file does not exitst.";
$err_msg->{'cheat'} = "...you dont really want to solve it this way";
$err_msg->{'email'} = "someone already entered this email-address";
$err_msg->{'ip'} = "someone already used this ip";
$variables->{err_msg} = $err_msg->{$error};
&template('error',$variables);
return exit;
}
################################################################
# parse and print template &Global::template(file,variables)
################################################################
sub template {
use CGI();
use CGI::Carp 'fatalsToBrowser';
my $template = $_[0] || "error";
my $variables = $_[1] || undef;
my $config = &config;
my $in = new CGI;
open (DATA, $template_path . "/" . $template . ".html") || &error('nofile');
print $in->header();
while (my $line = <DATA>) {
    # initialize our variables
    my $line_copy = '';
    my $changes = 0;
    # search for variables in the current line
    while ($line =~ /<%([^>]+)%>/) {
        # build up the new line with the section of $line prior to the
        # variable and the value for $var_name (check %variables, %config)
        ++$changes;
       if ($variables->{$1}) { $line_copy .= $` . $variables->{$1} }
       elsif ($config->{$1}) { $line_copy .= $` . $config->{$1} }
       else {
           --$changes;
           $line_copy .= $`;
           }
       # change $line to the section of $line after the variable
       $line = $';
    }
    # set $line according to whether or not any matches were found
    $line = $line_copy ? $line_copy . $line : $line;
    # print line depending on presence of 0: and variables existing
    if (($line !~ s/^0://) || !$line_copy || $changes) { print $line; }
}
close(DATA);
exit;
}
1;